## com.google.common.collect
Class ForwardingListMultimap<K,V>

    java.lang.Object
      com.google.common.collect.ForwardingObject
          com.google.common.collect.ForwardingMultimap<K,V>
              com.google.common.collect.ForwardingListMultimap<K,V>

All Implemented Interfaces:
  ListMultimap<K,V>, Multimap<K,V>

    @GwtCompatible
    public abstract class ForwardingListMultimap<K,V>

extends ForwardingMultimap<K,V>
implements ListMultimap<K,V>

A list multimap which forwards all its method calls to another list multimap. Subclasses should override one or more methods to modify the behavior of the backing multimap as desired per the decorator pattern.

Since:
  3.0
Author:
  Kurt Alfred Kluever

Constructor Summary
`protected` `ForwardingListMultimap()` Constructor for use by subclasses.

Method Summary
`protected abstract ListMultimap<K,V>` `delegate()` Returns the backing delegate instance that methods are forwarded to.
`List<V>` `get(K key)` Returns a collection view of all values associated with a key.
`List<V>` `removeAll(Object key)` Removes all values associated with a given key.
`List<V>` `replaceValues(K key, Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.

Methods inherited from class com.google.common.collect.ForwardingMultimap
`asMap, clear, containsEntry, containsKey, containsValue, entries, equals, hashCode, isEmpty, keys, keySet, put, putAll, putAll, remove, size, values`

Methods inherited from class com.google.common.collect.ForwardingObject
`toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.google.common.collect.ListMultimap
`asMap, equals`

Methods inherited from interface com.google.common.collect.Multimap
`clear, containsEntry, containsKey, containsValue, entries, hashCode, isEmpty, keys, keySet, put, putAll, putAll, remove, size, values`

Constructor Detail

### ForwardingListMultimap

    protected ForwardingListMultimap()

  Constructor for use by subclasses.

Method Detail

### delegate

    protected abstract ListMultimap<K,V> delegate()

  Description copied from class: `ForwardingObject`
  Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.

  Specified by:
    `delegate` in class `ForwardingMultimap<K,V>`

### get

    public List<V> get(@Nullable
                       K key)

  Description copied from interface: `Multimap`
  Returns a collection view of all values associated with a key. If no mappings in the multimap have the provided key, an empty collection is returned.

  Changes to the returned collection will update the underlying multimap, and vice versa.

  Specified by:
    `get` in interface `ListMultimap<K,V>`
  Specified by:
    `get` in interface `Multimap<K,V>`
  Overrides:
    `get` in class `ForwardingMultimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
  Returns:
    the collection of values that the key maps to

### removeAll

    public List<V> removeAll(@Nullable
                             Object key)

  Description copied from interface: `Multimap`
  Removes all values associated with a given key.

  Specified by:
    `removeAll` in interface `ListMultimap<K,V>`
  Specified by:
    `removeAll` in interface `Multimap<K,V>`
  Overrides:
    `removeAll` in class `ForwardingMultimap<K,V>`
  Parameters:
    `key` - key of entries to remove from the multimap
  Returns:
    the collection of removed values, or an empty collection if no values were associated with the provided key. The collection may be modifiable, but updating it will have no effect on the multimap.

### replaceValues

    public List<V> replaceValues(K key,
                                 Iterable<? extends V> values)

  Description copied from interface: `Multimap`
  Stores a collection of values with the same key, replacing any existing values for that key.

  Specified by:
    `replaceValues` in interface `ListMultimap<K,V>`
  Specified by:
    `replaceValues` in interface `Multimap<K,V>`
  Overrides:
    `replaceValues` in class `ForwardingMultimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

Copyright © 2010-2012. All Rights Reserved.